# How to Contribute

We'd love to accept your patches and contributions to this project. There are
just a few small guidelines you need to follow.

## Contributor License Agreement

Contributions to this project must be accompanied by a Contributor License
Agreement. You (or your employer) retain the copyright to your contribution,
this simply gives us permission to use and redistribute your contributions as
part of the project. Head over to <https://cla.developers.google.com/> to see
your current agreements on file or to sign a new one.

You generally only need to submit a CLA once, so if you've already submitted one
(even if it was for a different project), you probably don't need to do it
again.

## Code reviews

All submissions, including submissions by project members, require review. We
use GitHub pull requests for this purpose. Consult [GitHub
Help](https://help.github.com/articles/about-pull-requests/) for more
information on using pull requests.

## Source of Truth (SoT) and Commit Process

Cloudprober's source of truth is Google's internal copy of the code for various
reasons. To keep it that way, we first import the proposed pull request into
the internal copy of the code, get it reviewed internally, and then export it
back to Github. As a result of this, original PR is eventually discarded and a
new PR is merged into the master branch. All through this process, author
attribution is not lost. Final change will still appear to be done by you.
